初次刷LeetCode---Two Sun

總結(反省):

    1、不知道如何下手,沒看懂要求   

        實際上只是寫出求解問題的方法,參數之類的在方法參數列表中已傳。

    2、數組的長度arr.length,已經模糊

    3、for循環從0開始,竟然到arr.length結束

for(int i = 0; i <= arr.length;i++){
    ...
}

    4、方法返回值的忽略

-----------------------------------------------------------------------------------------------------------------------------------

以下是自己與答案之間的對比(感覺自己很差勁):

自己的:

public int[] twoSum(int[] nums, int target) {
        int[] arr = new int[2];
        for(int i = 0;i < nums.length;i++){
            for(int j = i + 1;j < nums.length ; j++){
                if(nums[i]+nums[j]==target){
                    arr[0] = i;
                    arr[1] = j; 
                }
            }
        }
        return arr;
    }

答案:

public int[] twoSum(int[] nums, int target) {
    for (int i = 0; i < nums.length; i++) {
        for (int j = i + 1; j < nums.length; j++) {
            if (nums[j] == target - nums[i]) {
                return new int[] { i, j };
            }
        }
    }
    throw new IllegalArgumentException("No two sum solution");
}

不僅如此,上面的答案只是一種蠻力(Brute Force)求解的過程,根本沒有編程之美( ∩_∩ ,自我狼狽中~~)

這裏給個好的(One-pass Hash Table):

public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        int complement = target - nums[i];
        if (map.containsKey(complement)) {
            return new int[] { map.get(complement), i };
        }
        map.put(nums[i], i);
    }
    throw new IllegalArgumentException("No two sum solution");
}

下面給出鏈接 可以自己去體驗

https://leetcode.com/articles/two-sum/

-----------------------------------------------------------------------------------------------------------------------------------原題:

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

翻譯:

給定一組整數,將兩個數的返回指數相加,使它們相加成一個特定的目標。
您可以假設每個輸入都有一個解決方案,您可能不會使用相同的元素兩次。



    
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章